use std::{collections::HashSet, fs};

pub fn start() {
	let input = fs::read_to_string("./day3/src/input.txt").unwrap();

	let items = vec![
		'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
		's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
		'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	];

	let mut sum = 0;
	input
		.to_owned()
		.lines()
		.map(|f| f.split_at(f.len() / 2))
		.for_each(|f| {
			let pack1_ids = priority(f.0, items.clone());
			let pack2_ids = priority(f.1, items.clone());

			let prio = pack1_ids
				.iter()
				.filter(|p| pack2_ids.contains(p))
				.collect::<Vec<&usize>>()
				.first()
				.unwrap()
				.to_owned();

			sum += prio;
		});

	println!("{:#?}", sum);

	sum = 0;

	input
		.lines()
		.collect::<Vec<&str>>()
		.chunks(3)
		.map(|f| {
			f.iter()
				.map(|f| priority(f, items.clone()))
				.collect::<Vec<Vec<usize>>>()
		})
		.map(|f| intersection(f).first().unwrap().clone())
		.for_each(|f| sum += f);

	println!("{:#?}", sum);
}

pub fn intersection(nums: Vec<Vec<usize>>) -> Vec<usize> {
	let mut res: Vec<usize> = nums[0].clone();

	for temp_vec in nums {
		let set: HashSet<usize> = temp_vec.into_iter().collect();
		res = set
			.intersection(&res.into_iter().collect())
			.map(|i| *i)
			.collect::<Vec<_>>();
	}
	res
}

pub fn priority(str: &str, items: Vec<char>) -> Vec<usize> {
	str.chars()
		.map(|c| items.iter().position(|p| p == &c).unwrap() + 1)
		.collect::<Vec<usize>>()
}
