use std::{fs, ops::Range};

pub fn start() {
	let input = fs::read_to_string("./day4/src/input.txt").unwrap();

	let mut sum1 = 0;
	let mut sum2 = 0;
	input
		.lines()
		.map(|f| {
			f.split(",")
				.collect::<Vec<&str>>()
				.iter()
				.map(|f| {
					f.split("-")
						.map(|f| f.parse::<u32>().unwrap())
						.collect::<Vec<u32>>()
				})
				.collect::<Vec<Vec<u32>>>()
		})
		.for_each(|f| {
			let i1 = f.get(0).unwrap();
			let i2 = f.get(1).unwrap();

			let r1 = Range {
				start: i1.get(0).unwrap().to_owned(),
				end: i1.get(1).unwrap().to_owned(),
			};
			let r2 = Range {
				start: i2.get(0).unwrap().to_owned(),
				end: i2.get(1).unwrap().to_owned(),
			};

			if (r1.start >= r2.start && r1.end <= r2.end)
				|| (r2.start >= r1.start && r2.end <= r1.end)
			{
				sum1 += 1;
			}

			if r1.start == r2.start
				|| r1.end == r2.end
				|| r1.contains(&r2.start)
				|| r1.contains(&r2.end)
				|| r2.contains(&r1.start)
				|| r2.contains(&r1.end)
			{
				sum2 += 1;
			}
		});

	println!("Part 1: {:#?}", sum1);
	println!("Part 2: {:#?}", sum2)
}
